var Base64 = {
    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
            this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }
        return string;
    }
}

var global_document_url = "";
var global_vid_mate_video_id = "";

function vid_mate_get_video_id(url) {
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}

	if(-1 == vid_mate_url.indexOf("fullmovies.net.in"))
	{
		return null;
	}

	var tmp_re = new RegExp("video.php\\\?id=(.+?)&");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[1];
	}
	return null;
}

function vid_mate_check(url) {
	if (vid_mate_get_video_id(url) == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url) {
	if(null == url || undefined == url || 0 == url.length)
	{
		return vid_mate_get_video_info_on_blank(document.URL);
	}
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	if(null == vid_mate_video_id)
	{
		return;
	}
	global_document_url = url;
	global_vid_mate_video_id = vid_mate_video_id;
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	var param_id = vid_mate_get_parameter(url, "id");
	var param_url = vid_mate_get_parameter(url, "url");
	var videoUrl = Base64.decode(param_url);
	if(!videoUrl)
	{
		vid_mate_error_default('fullmoviesnetin 1');
		return null;
	}

    vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "fullmoviesnetin";
	var tmp_video_file = new vid_mate_video_file();
	rtn_video.id = global_vid_mate_video_id;

	var videoTitle = "mp4";
	var tmp_re = new RegExp("mp4\/(.+?)-FREEVIDS.IN");
	if (tmp_re.test(videoUrl)) {
		var tmp_m = videoUrl.match(tmp_re);
		videoTitle = tmp_m[1];
		videoTitle = decodeURIComponent(videoTitle);
		videoTitle = videoTitle.replace(/-/g, " ");
	}
	var videoImg = "http://i1.ytimg.com/vi/"+param_id+"/default.jpg";

	rtn_video.title = videoTitle;
	rtn_video.url = global_document_url;
	rtn_video.picture_default = videoImg;
	rtn_video.picture_big = videoImg;

	tmp_video_file.url = videoUrl;
	tmp_video_file.f_id = rtn_video.id;
	var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
	tmp_video_file.format = tmp_format;
	tmp_video_file.title = tmp_format;

	rtn_video.files.push(tmp_video_file);
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}


